# NACCFC.tcl---NAC Camac to FERA readout controller  control frame



set frame NACCFC
set frametitle "NAC Camac to FERABus Controller"
set icontitle "NACCFC"

set debug 0
set started 0 
set nafcount 0
set mname "naccfc"
set dataval 0
set idataval 0
set copylist {}
set vsnnumber 0
set cname "NAC CFC"
#set maxadc 0
set counter 1

set Configdir "$env(MIDASEXPBASE)"
catch {set Configdir "$env(EXPERIMENTBASE)"}

#set maxmodule 1
#set module 1

set maxmodule [inform camaccontrol inquire [set mname]count]
set modulelist {}
for {set i 1} {$i <= $maxmodule} {incr i} {lappend modulelist $i}

set module [first $modulelist]


set rrname(CLEAR)        clear_enable
set rrname(SET)          set_enable
set rrname(RESET)        reset

loadsource common.camac
set reset_cmd  reset
set nsel 0
set asel 0
set fsel 0
set selection -1
set redatavalue 0

set m {{ n            a            f     }}
set occupied {}

set ndatalist {}

set defaultlist {}

#set Configdir 
proc set-experiment dir {
   global env Configdir
#   set LUTdir $dir
   set Configdir $dir
}


proc make-datalist {} {
    global ndatalist  
    global occupied; catch {unset occupied};global occupied
    set selection 0
    foreach data $ndatalist {
	set nsel [first $data]
	set asel [second $data]
	set fsel [third $data]
	set ndatalist [lreplace $ndatalist $selection $selection  \
		[list $nsel $asel $fsel]]
	incr selection
    }
    paint-datalist
    repaint
}

proc format-data l {
  set ll {}
  foreach f $l {lappend ll [format "%8s %12s %12s" \
   [first $f] [second $f] [third $f]]}
  return $ll
}

proc load-data n {
    global ndatalist nsel asel fsel
    set data [lindex $ndatalist $n]

    set nsel [first $data]
    set asel [second $data]
    set fsel [third $data]
}

#proc click-redisplay {} {
#   global env debug
#   if {$debug} then {insert-debug "click-redisplay"}
#   :modify REDISPLAY :busy T
#   paint-datalist
#   repaint
#   :modify REDISPLAY :busy F
#}

proc click-startdisplay {} {
   global debug ndatalist nsel asel fsel redatavalue nafcount
   set nafregs [list cmd0 naf1 naf2 naf3 naf4 naf5 naf6 naf7 naf8 naf9 naf10 naf11 naf12 naf13 naf14 naf15]
   if {$debug} then {puts stderr "redisplay-module"}
   camac-address
   set nafcount 0
   for {set i 1} {$i <= 15} {incr i} {
       set register [lindex $nafregs $i]
       set redatavalue [read-reg $register]
       #puts $redatavalue
       if {$redatavalue != 0} {
	   set nsel [expr $redatavalue >> 9]
	   set asel [expr [expr $redatavalue >> 5] & 15]
	   set fsel [expr $redatavalue & 31]
	   lappend ndatalist  [list $nsel $asel $fsel]
	   incr nafcount
#	   make-datalist
       }
#       load-configuration
   }
#   load-configuration
   make-datalist
   clear-footer
}

proc click-datalist {c s} {
  global debug selection
  if {$debug} then {insert-debug "click-datalist with arguments \{$c $s\}"}
  case $c in {
    :list-select {set selection $s; load-data $selection}
    :list-deselect {set selection -1}
  }
  repaint
  clear-footer
}

proc Configuration {} {global ndatalist; return $ndatalist}

proc HasBeenConfigured {} {read-register NetVar_HasBeenConfigured}

proc load-configuration {} {
    global env debug mname dataval ndatalist nafcount camstation copylist vsnnumber cname wname datalist
    set nafregs [list cmd0 naf1 naf2 naf3 naf4 naf5 naf6 naf7 naf8 naf9 naf10 naf11 naf12 naf13 naf14 naf15]
    set selection 0
    set copylist [inform camaccontrol inquire datalist]
    foreach data $copylist {
	set wname [second $data]
	if {[string compare $wname $cname]} {
	    set vsnnumber [fifth $data]
	}
    }
    for {set i 0} {$i <= 15} {incr i} {
    set register [lindex $nafregs $i]
	write-reg $register 0 }
    set register clear_enable
    read-reg $register
    set dataval [expr $vsnnumber + [expr $nafcount << 8] + [expr 8 << 12]]
    set register cmd0
    write-reg $register $dataval
    puts $vsnnumber
    puts $dataval
    set counter 1
    foreach data $ndatalist {
	set register [lindex $nafregs $counter]
	set idataval [expr [third $data] +[expr [second $data] << 5] + [expr [first $data] << 9]]
	write-reg $register $idataval
	incr counter
    }
#    puts $idataval
#    set register set_enable
#    read-reg $register
}

#

proc restore_configuration {} {make-datalist}

#proc restore_configuration {} {
#   global env Configdir resource datalist
#
#   set datalist ""
#
#   set z [catch {open [file join $Configdir [ set resource]_present_configuration] r} file]
#   if {$z != 0} then {set-footer "$file"; return}
#
#   set configuration [split [read $file] \n]
#   close $file
#   set l [expr [llength $configuration] - 1]
#   set datalist [lreplace $configuration $l $l]
#   make-datalist
#}


proc paint-datalist {} {
    global env ndatalist selection
    global m
    set pointstrings [format-data $ndatalist]
    set strings [format-data $m]
      :modify M :empty T :strings "$strings"
      :modify CONFIG-DATALIST :show F :empty T :strings "$pointstrings" :show T
      :modify CONFIG-DATALIST :select $selection
      :modify CONFIG-DATALIST :see 0
}

proc repaint-selection {} {
  global selection
    :modify CONFIG-DATALIST :select $selection
}

proc click-clear {} {
   global ndatalist nafcount
   set ndatalist {}
   set nafcount 0
   paint-datalist
#   load-configuration
}

proc click-add {} {
   global ndatalist nsel asel fsel nafcount
   lappend ndatalist  [list $nsel $asel $fsel]
    incr nafcount
   make-datalist
   clear-footer
    load-configuration
}

proc click-delete {} {
   global selection ndatalist nafcount 
   if {$selection<0} then \
      {set-footer "No line selected to delete"; return}
   set ndatalist [lreplace $ndatalist $selection $selection]
   set nafcount [expr $nafcount - 1]
   set selection -1
   make-datalist
   clear-footer
   load-configuration
}

proc click-insert {} {
    global selection ndatalist nafcount nsel asel fsel
#    if {$selection<0} then \
#	    {set-footer "No line selected"; return}
   if {$selection<0} then \
      {set-footer "No line selected to insert before"; return}
    set ndatalist [linsert $ndatalist $selection [list $nsel $asel $fsel]]
    incr nafcount
    set selection -1
    make-datalist
    clear-footer
    load-configuration
}

proc click-nbutton {n} {
    global nsel nselchoice
    set nsel [lindex $nselchoice $n]
}

proc click-abutton {n} {
    global asel aselchoice
    set asel [lindex $aselchoice $n]
}

proc click-fbutton {n} {
    global fsel fselchoice
    set fsel [lindex $fselchoice $n]
}


proc click-replace {} {
   global selection 
   global ndatalist nsel asel fsel
   if {$selection<0} then \
      {set-footer "No line selected to replace"; return}
   set ndatalist [lreplace $ndatalist $selection $selection \
                     [list $nsel $asel $fsel]]
   make-datalist
   clear-footer
}

set nselchoice {}
for {set i 0} {$i <= 15} {incr i} {lappend nselchoice $i}

set aselchoice {}
for {set i 0} {$i <= 15} {incr i} {lappend aselchoice $i}

set fselchoice {}
for {set i 0} {$i <= 15} {incr i} {lappend fselchoice $i}

proc repaint {} {}

proc redisplay-module {} {
   global debug
   if {$debug} then {puts stderr "redisplay-module"}
   camac-address
}

proc click arg {
   global debug rrname wrname
   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   if {$c==":quit"} then {click-quit; return}
   if {$c==":Enter"} then {repaint-selection; return}
   switch -glob $w {

      CLEAR  -
      SET  -
      RESET      {read-reg $rrname($w)}

      MODULE-SEL-MENU -
      MODULE-NUM      -
      MODULE-SEL      {click-select-module $v;click-clear;click-startdisplay}

      NSEL {click-nbutton $v}
      ASEL {click-abutton $v}
      FSEL {click-fbutton $v}

      ADD {click-add}
      REPLACE {click-replace}
      DELETE {click-delete}
      CLEARD {click-clear}

      LOAD {load-configuration}
      CONFIG-DATALIST {click-datalist $c [lindex $arg 4]}
      INSERT {click-insert}

      REDISPLAY {click-redisplay;click-clear;click-startdisplay}
      
#      SAVERESTORE    {inform cfcsaverestore CSRstart}


      default   {puts stdout $arg}
      }
   click-redisplay
}

proc start args {
   global  started
   if {$started == 0} then {load_preferences; make-frame; restore_configuration}
   open-frame
#   initialise
#   click-startdisplay
   click-redisplay
}

proc autostart args {
   global  started
   if {$started == 0} then {start; close-frame} else {continue}
}

proc click-quit args {close-frame}

proc finish args {destroy-frame}

set selectmodulemenu {1}


proc make-frame {} {
  global env maxmodule camcrate camstation nchannels nselchoice aselchoice fselchoice 
  global selectmodulemenu modulelist

    set started 1

  :frame [self frame-name] :label "[self frame-title]" :show-footer T \
      :icon-image "@$env(ICONHOME)/camac_module" \
      :icon-name "[self icon-title]" :resize F

   :panel MODULE :layout T :padx 10
      :layout H; :row-gap 20
#      :hskip 10
      :number MODULE-NUM  :label "Module number:" :min 1 :max $maxmodule :w 5 
      :menubutton MODULE-SEL :label "select:" :strings $modulelist
      :next-row T
      :text CAM-CRATE   :label "CAMAC Crate:"    :w 5 :value $camcrate   :deaf T
      :text CAM-STATION :label "CAMAC Station:"  :w 5 :value $camstation :deaf T

      :next-row T; :col-gap 50
      :button RESET  :label "Generate Reset"
#      :next-row T
      :button CLEAR   :label "Clear Enable"
      :button SET  :label "Set Enable"
    :panel CONFIGURATION  :layout T :padx 10 :pady 10
      :layout V; :row-gap 10; :col-gap 10
      :list M :rows 2 :cols 45 :strings [list ""] :deaf T
      :list CONFIG-DATALIST  :rows 16 :cols 45 :exclusive T :strings [list ""]
#      :double-click T
    :panel OPTIONS :layout T :padx 10
      :layout H; :row-gap 10; :col-gap 15
      :choice-stack NSEL :label "n:" :exclusive T :strings "$nselchoice" :value 0
      :choice-stack ASEL :label "a:" :exclusive T :strings "$aselchoice" :value 0
      :choice-stack FSEL :label "f:" :exclusive T :strings "$fselchoice" :value 0
    :panel CLICK :layout T :padx 10
      :layout H; :row-gap 10; :col-gap 15
      :vskip 10
      :button ADD :label Add
      :button REPLACE :label Replace
      :button DELETE :label Delete
      :button CLEARD :label Clear
      :next-row T
#      :button LOAD :label "Load Configuration into module"
      :button INSERT :label "Insert before"
    :panel DISP :layout T :padx 10
      :layout H; :row-gap 10; :col-gap 10
      :vskip 10
      :button REDISPLAY :label "Redisplay"
#      :button SAVERESTORE    :label "Save/Restore Setup"
   :show T

}

#proc EG args {puts stdout "$args"; return 7}







