#    most of this task is now taken from the standard fera application


set frametitle "MIDAS Data Acquisition Experiment Control (Afrodite)"

set TSEnable 1
set txEnable 1

set TestBuffer "80010000  0fff0080  01000180  02000010  00200030  00400000  00000000  03000070  8403005a 12003400 5600ffff ffff8000"

proc create_clover_spectra {module vsn} {
   global SpectrumServer HistMode

   set adcnames [list HitPatt GeA GeB GeC GeD TacA TacB TacC TacD "" "" "" BGOSum BGOTac]
   set adclengths [list 32768 16384 16384 16384 16384 4096 4096 4096 4096 0 0 0 4096 4096]

#     RIS Corp Clover module

    DefineConfig "$vsn 5 1 0 0 0"

    if {$HistMode == 0} {return}

     for {set j 0} {$j <= 14} {incr j} {
         set adc [lindex $adcnames $j]
         set len [lindex $adclengths $j]
         if {$adc != ""} {

            set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $len :name '$module.$adc' !new)" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
            if {$z!=0 && $m==0x30004} then {set z 0}
            if {$z!=0} then {
               display-eg-error-report self $m "Attempting to create spectrum $module.$adc"
               clear-footer
               error $m
            } else {
               map_spectrum "$module.$adc $vsn $j"
 #insert-log "created $module.$adc for vsn=$vsn and sub address=$j"
            }
         }
    }
}

proc define_NACCFC_module {module vsn} {

    DefineConfig "$vsn 6 1 0xffff 0 0"
}

